/* USER CODE BEGIN Header */
/****************************************************************************\
* 		CAN模式驱动示例-HAL库函数版V1.0 2022.08.20
* 		支持型号：TOFSense/TOFSense-P/PS/M/MS
* 		官方网站：https://www.nooploop.com/
* 		淘宝店铺： https://nooploop.taobao.com/
* 		深圳空循环科技有限公司
* 		用精准定位技术为行业赋能！
\****************************************************************************/
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "can.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
#define mode_flag  	  2			//0:主动输出模式   1:查询输出模式    2:级联模式
#define model_number  0  		//根据用户的模块型号更改，用作加大M型号每两帧之间的等待时间
								//0:TOFSense/TOFSense-P/PS
								//1:TOFSense-M/MS
#ifdef  model_number
uint8_t interval = 70;			//M型号的采集最小间隔
#else
uint8_t interval = 20;			//其他型号的采集最小间隔
#endif

uint8_t can_id = 0;				//级联时用作更改查询ID
uint8_t can_tx_buf[8] = {0xff,0xff,0xff,0x00,0xff,0xff,0xff,0xff};	//查询命令
uint8_t	can_rx_buf[8];			//缓存数组

//TOFSense/TOFSense-P/PS can数据结构体
typedef struct{
	uint8_t ID;

	float dis;					//解包后的距离数据
	uint8_t dis_status;			//解包后的距离状态指示
	uint16_t signal_strength;	//解包后的信号强度

}Tofsnese_can;

Tofsnese_can Tof[8];

//TOFSense-M/MS can数据结构体
typedef struct{
	uint8_t ID;

	float dis[64];					//解包后的距离数据
	uint8_t dis_status[64];			//解包后的距离状态指示
	uint16_t signal_strength[64];	//解包后的信号强度

}Tofsnesem_can;

Tofsnesem_can Tof_m[8];
/******************************************************************************
函数名称  ：Tof_can_Unpack_Data
函数功能 ： 将接收到一帧数据进行解包，并将解包后的数据存入结构体变量中
参    数 ： 无
返 回 值 ： 无
调用方法：在中断中调用Tof_can_Unpack_Data();进行解包操作
支持模块：TOFSense/TOFSense-P/PS
*******************************************************************************/

void Tof_can_Unpack_Data(uint8_t id)
{
	int32_t temp = 0;

	temp = (int32_t)(can_rx_buf[0] << 8 | can_rx_buf[1] << 16 | can_rx_buf[2] << 24)/256;	//计算此帧数据距离
	Tof[id].dis = temp/1000.0f;										//除以1000后单位为m

	Tof[id].dis_status = can_rx_buf[3];								//此帧距离状态指示
	Tof[id].signal_strength = can_rx_buf[4] | can_rx_buf[5] <<8;	//此帧信号强度
}

/******************************************************************************
函数名称  ：Tofm_can_Unpack_Data
函数功能 ： 将接收到一帧数据进行解包，并将解包后的数据存入结构体变量中
参    数 ： 无
返 回 值 ： 无
调用方法：在中断中调用Tofm_can_Unpack_Data();进行解包操作
支持模块：TOFSense-M/MS
*******************************************************************************/
void Tofm_can_Unpack_Data(uint8_t id)
{
	int32_t temp = 0;
	uint8_t index;

	index = can_rx_buf[6];

	temp = (int32_t)(can_rx_buf[0] << 8 | can_rx_buf[1] << 16 | can_rx_buf[2] << 24)/256;	//计算此帧数据距离
	Tof_m[id].dis[index] = temp/1000.0f;										//除以1000后单位为m

	Tof_m[id].dis_status[index] = can_rx_buf[3];								//此帧距离状态指示
	Tof_m[id].signal_strength[index] = can_rx_buf[4] | can_rx_buf[5] <<8;	//此帧信号强度
}

//中断回调函数
//弱函数重写保持函数名一致即可
void HAL_CAN_RxFifo0MsgPendingCallback(CAN_HandleTypeDef *hcan)
{
	uint8_t id = 0;
	if(hcan->Instance==CAN1)
	{
		HAL_CAN_GetRxMessage(&hcan1,CAN_FILTER_FIFO0,&RxHeader,can_rx_buf);//获取数据
		id = (uint8_t)(RxHeader.StdId & 0xFF);							//获取此帧数据ID

		if(model_number)
		{
			Tof_m[id].ID = id;
			Tofm_can_Unpack_Data(id);
		}
		else
		{
			Tof[id].ID = id;
			Tof_can_Unpack_Data(id);
		}
	}
}

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_CAN1_Init();
  /* USER CODE BEGIN 2 */

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
	if(mode_flag == 0)				//主动输出模式
	{
	}
	else if(mode_flag == 1)			//查询输出模式
	{
		HAL_CAN_AddTxMessage(&hcan1, &TxHeader, can_tx_buf, (uint32_t*)CAN_TX_MAILBOX0);	//发送对应ID请求命令
		HAL_Delay(interval);
	}
	else if(mode_flag == 2)			//级联模式
	{
		HAL_CAN_AddTxMessage(&hcan1, &TxHeader, can_tx_buf, (uint32_t*)CAN_TX_MAILBOX0);	//发送对应ID请求命令
		can_id++;
		if(can_id >= 8)
		{
			can_id = 0;
		}
		can_tx_buf[3] = can_id;
		HAL_Delay(interval/5);
	}
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 4;
  RCC_OscInitStruct.PLL.PLLN = 168;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 4;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV4;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV2;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_5) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
